<!-- // deno-fmt-ignore-file -->

## NHttp

Fast native http framework for [Deno](https://deno.land/),
[Deno Deploy](https://deno.com/deploy) and
[Cloudflare Workers](https://workers.cloudflare.com).

> this version idealy for cloudflare workers with wrangle.

> this module generated by => esbuild mod.ts --bundle --platform=node
> --outfile=cf_workers/index.js --target=node10.4

## Usage With Wrangler

### Install deps

```bash
npm install @cloudflare/wrangler -g
npm install nhttp-workers --save
```

### Generate App

```bash
wrangler generate app_name
cd app_name
```

### Webpack

Modify wrangler.toml

```toml
name = "app_name"
type = "webpack"

account_id = "your_account_id"
workers_dev = true
route = ""
zone_id = ""
```

### Code

Modify index.js

```js
const { NHttp } = require("nhttp-workers");

const app = new NHttp();

app.get("/hello", ({ response }) => {
  return response.send("hello");
});

// directly
app.get("/hello2", () => {
  return "hello";
});

// fetch / listen
addEventListener("fetch", app.fetchEventHandler());
```

### Run Development

```bash
wrangler dev
```

More info https://developers.cloudflare.com/workers/

## License

[MIT](LICENSE)
